#ifndef LIB_DBG_DEBUG_MQLAPI_MQL4_TRACER_MQH_INCLUDED
#define LIB_DBG_DEBUG_MQLAPI_MQL4_TRACER_MQH_INCLUDED
#property version "5.10";
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the debugger library include file.
 *
 * This file may be copied and/or distributed at free will.
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 5.10
 *  State: public
 *
 *  File information
 *  ================
 *
*/




//*********************************************************************************************************************************************************/
//  BEGIN MQLAPI tracer
//



/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MQL4 API function call meta object
//


    class LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_mql4) : public LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_mql45)
    {
        public:
        // Debug location recorder

            LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_mql4)* trace_call_details(const int _line_in, const char _func_id, const string _file_in, const string _function_in, const string _mqlapi_func, const string _api_name = NULL)
            {
                // Base class function
                LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object)::trace_call_details(_line_in, _func_id, _file_in, _function_in, _mqlapi_func, _api_name);

                // Return
                return(GetPointer(this));
            };


        // MQL-API rewrite functions with return values

            double dbg_mqlapi_trace_func_AccountBalance()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountBalance();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_AccountCompany()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountCompany();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_AccountCredit()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountCredit();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_AccountCurrency()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountCurrency();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_AccountEquity()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountEquity();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_AccountFreeMargin()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountFreeMargin();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_AccountFreeMarginCheck(string symbol, int cmd, double volume)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, cmd, volume, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountFreeMarginCheck(symbol, cmd, volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_AccountFreeMarginMode()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountFreeMarginMode();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_AccountLeverage()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountLeverage();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_AccountMargin()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountMargin();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_AccountName()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountName();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_AccountNumber()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountNumber();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_AccountProfit()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountProfit();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_AccountServer()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountServer();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_AccountStopoutLevel()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountStopoutLevel();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_AccountStopoutMode()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = AccountStopoutMode();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ArrayCopyRates(MqlRates& rates_array[], string symbol = NULL, int timeframe = 0)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, timeframe, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ArrayCopyRates(rates_array, symbol, timeframe);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, rates_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T>
            int dbg_mqlapi_trace_func_ArrayCopyRates(T& dest_array[][], string symbol = NULL, int timeframe = 0)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, timeframe, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ArrayCopyRates(dest_array, symbol, timeframe);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dest_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T>
            int dbg_mqlapi_trace_func_ArrayCopySeries(T& array[], int series_index, string symbol = NULL, int timeframe = 0)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, series_index, symbol, timeframe, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ArrayCopySeries(array, series_index, symbol, timeframe);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T>
            int dbg_mqlapi_trace_func_ArrayDimension(T& array[])
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ArrayDimension(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_CharToStr(uchar char_code)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, char_code, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = CharToStr(char_code);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Day()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = Day();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DayOfWeek()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = DayOfWeek();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DayOfYear()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = DayOfYear();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_DoubleToStr(double value, int digits)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value, digits, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = DoubleToStr(value, digits);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_FileOpenHistory(string filename, int mode, int delimiter = ';')
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, filename, mode, delimiter, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = FileOpenHistory(filename, mode, delimiter);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Hour()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = Hour();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iAC(string symbol, int timeframe, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iAC(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iAD(string symbol, int timeframe, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iAD(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iADX(string symbol, int timeframe, int period, int applied_price, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, timeframe, period, applied_price, mode, shift, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iADX(symbol, timeframe, period, applied_price, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iAlligator(string symbol, int timeframe, int jaw_period, int jaw_shift, int teeth_period, int teeth_shift, int lips_period, int lips_shift, int ma_method, int applied_price, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, lips_shift, ma_method, applied_price, mode, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iAlligator(symbol, timeframe, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, ma_method, applied_price, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iAO(string symbol, int timeframe, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iAO(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iATR(string symbol, int timeframe, int period, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, period, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iATR(symbol, timeframe, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iBands(string symbol, int timeframe, int period, double deviation, int bands_shift, int applied_price, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, shift, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, period, deviation, bands_shift, applied_price, mode);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iBands(symbol, timeframe, period, deviation, bands_shift, applied_price, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iBandsOnArray(double& array[], int total, int period, double deviation, int bands_shift, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, array, total, period, deviation, bands_shift, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iBandsOnArray(array, total, period, deviation, bands_shift, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iBearsPower(string symbol, int timeframe, int period, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, period, applied_price, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iBearsPower(symbol, timeframe, period, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iBullsPower(string symbol, int timeframe, int period, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, period, applied_price, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iBullsPower(symbol, timeframe, period, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iBWMFI(string symbol, int timeframe, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iBWMFI(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iCCI(string symbol, int timeframe, int period, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, period, applied_price, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iCCI(symbol, timeframe, period, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iCCIOnArray(double& array[], int total, int period, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, array, total, period, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iCCIOnArray(array, total, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iDeMarker(string symbol, int timeframe, int period, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, period, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iDeMarker(symbol, timeframe, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iEnvelopes(string symbol, int timeframe, int ma_period, int ma_method, int ma_shift, int applied_price, double deviation, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, mode, shift, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, ma_period, ma_method, ma_shift, applied_price, deviation);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iEnvelopes(symbol, timeframe, ma_period, ma_method, ma_shift, applied_price, deviation, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iEnvelopesOnArray(double& array[], int total, int ma_period, int ma_method, int ma_shift, double deviation, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, shift, 0, 0, 0, 0, 0, 0);;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, array, total, ma_period, ma_method, ma_shift, deviation, mode);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iEnvelopesOnArray(array, total, ma_period, ma_method, ma_shift, deviation, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iForce(string symbol, int timeframe, int period, int ma_method, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, timeframe, period, ma_method, applied_price, shift, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iForce(symbol, timeframe, period, ma_method, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iFractals(string symbol, int timeframe, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, mode, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iFractals(symbol, timeframe, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iGator(string symbol, int timeframe, int jaw_period, int jaw_shift, int teeth_period, int teeth_shift, int lips_period, int lips_shift, int ma_method, int applied_price, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, lips_shift, ma_method, applied_price, mode, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iGator(symbol, timeframe, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, ma_method, applied_price, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iIchimoku(string symbol, int timeframe, int tenkan_sen, int kijun_sen, int senkou_span_b, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, tenkan_sen, kijun_sen, senkou_span_b, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iIchimoku(symbol, timeframe, tenkan_sen, kijun_sen, senkou_span_b, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iMA(string symbol, int timeframe, int ma_period, int ma_shift, int ma_method, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, ma_period, ma_shift, ma_method, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iMA(symbol, timeframe, ma_period, ma_shift, ma_method, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iMAOnArray(double& array[], int total, int ma_period, int ma_shift, int ma_method, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, array, total, ma_period, ma_shift, ma_method, shift, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iMAOnArray(array, total, ma_period, ma_shift, ma_method, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iMACD(string symbol, int timeframe, int fast_ema_period, int slow_ema_period, int signal_period, int applied_price, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, shift, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, fast_ema_period, slow_ema_period, signal_period, applied_price, mode);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iMACD(symbol, timeframe, fast_ema_period, slow_ema_period, signal_period, applied_price, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iMFI(string symbol, int timeframe, int period, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, period, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iMFI(symbol, timeframe, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iMomentum(string symbol, int timeframe, int period, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, period, applied_price, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iMomentum(symbol, timeframe, period, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iMomentumOnArray(double& array[], int total, int period, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, array, total, period, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iMomentumOnArray(array, total, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorBuffers(int count)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, count, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IndicatorBuffers(count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_IndicatorCounted()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IndicatorCounted();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iOBV(string symbol, int timeframe, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, applied_price, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iOBV(symbol, timeframe, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iOsMA(string symbol, int timeframe, int fast_ema_period, int slow_ema_period, int signal_period, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, fast_ema_period, slow_ema_period, signal_period, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iOsMA(symbol, timeframe, fast_ema_period, slow_ema_period, signal_period, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iRSI(string symbol, int timeframe, int period, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, period, applied_price, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iRSI(symbol, timeframe, period, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iRSIOnArray(double& array[], int total, int period, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, array, total, period, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iRSIOnArray(array, total, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsConnected()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsConnected();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsDemo()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsDemo();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsDllsAllowed()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsDllsAllowed();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsExpertEnabled()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsExpertEnabled();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsLibrariesAllowed()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsLibrariesAllowed();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsOptimization()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsOptimization();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iRVI(string symbol, int timeframe, int period, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, period, mode, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iRVI(symbol, timeframe, period, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iSAR(string symbol, int timeframe, double step, double maximum, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, step, maximum, shift, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iSAR(symbol, timeframe, step, maximum, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iStdDev(string symbol, int timeframe, int ma_period, int ma_shift, int ma_method, int applied_price, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, ma_period, ma_shift, ma_method, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iStdDev(symbol, timeframe, ma_period, ma_shift, ma_method, applied_price, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iStdDevOnArray(double& array[], int total, int ma_period, int ma_shift, int ma_method, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, array, total, ma_period, ma_shift, ma_method, shift, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iStdDevOnArray(array, total, ma_period, ma_shift, ma_method, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iStochastic(string symbol, int timeframe, int Kperiod, int Dperiod, int slowing, int method, int price_field, int mode, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, mode, shift, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, timeframe, Kperiod, Dperiod, slowing, method, price_field);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iStochastic(symbol, timeframe, Kperiod, Dperiod, slowing, method, price_field, mode, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsTesting()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsTesting();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsTradeAllowed()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsTradeAllowed();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsTradeContextBusy()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsTradeContextBusy();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsVisualMode()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = IsVisualMode();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_iTime(string symbol, int timeframe, int shift)
            {
                datetime retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iTime(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_iVolume(string symbol, int timeframe, int shift)
            {
                long retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iVolume(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iWPR(string symbol, int timeframe, int period, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, period, shift, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = iWPR(symbol, timeframe, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

            double dbg_mqlapi_trace_func_MarketInfo(string symbol, int type)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, type, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = MarketInfo(symbol, type);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_MathAbs(char value)                                   { return(MathAbs_T<int, char>(value)); }
            int dbg_mqlapi_trace_func_MathAbs(short value)                                  { return(MathAbs_T<int, short>(value)); }
            int dbg_mqlapi_trace_func_MathAbs(int value)                                    { return(MathAbs_T<int, int>(value)); }
            long dbg_mqlapi_trace_func_MathAbs(long value)                                  { return(MathAbs_T<long, long>(value)); }
            uchar dbg_mqlapi_trace_func_MathAbs(uchar value)                                { return(MathAbs_T<uchar, uchar>(value)); }
            ushort dbg_mqlapi_trace_func_MathAbs(ushort value)                              { return(MathAbs_T<ushort, ushort>(value)); }
            uint dbg_mqlapi_trace_func_MathAbs(uint value)                                  { return(MathAbs_T<uint, uint>(value)); }
            ulong dbg_mqlapi_trace_func_MathAbs(ulong value)                                { return(MathAbs_T<ulong, ulong>(value)); }
            float dbg_mqlapi_trace_func_MathAbs(float value)                                { return(MathAbs_T<float, float>(value)); }
            double dbg_mqlapi_trace_func_MathAbs(double value)                              { return(MathAbs_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(short value)                            { return(MathArccos_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(int value)                              { return(MathArccos_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(long value)                             { return(MathArccos_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(uchar value)                            { return(MathArccos_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(ushort value)                           { return(MathArccos_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(uint value)                             { return(MathArccos_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(ulong value)                            { return(MathArccos_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(float value)                            { return(MathArccos_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathArccos(double value)                           { return(MathArccos_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(char value)                             { return(MathArcsin_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(short value)                            { return(MathArcsin_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(int value)                              { return(MathArcsin_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(long value)                             { return(MathArcsin_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(uchar value)                            { return(MathArcsin_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(ushort value)                           { return(MathArcsin_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(uint value)                             { return(MathArcsin_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(ulong value)                            { return(MathArcsin_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(float value)                            { return(MathArcsin_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathArcsin(double value)                           { return(MathArcsin_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(char value)                             { return(MathArctan_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(short value)                            { return(MathArctan_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(int value)                              { return(MathArctan_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(long value)                             { return(MathArctan_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(uchar value)                            { return(MathArctan_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(ushort value)                           { return(MathArctan_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(uint value)                             { return(MathArctan_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(ulong value)                            { return(MathArctan_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(float value)                            { return(MathArctan_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathArctan(double value)                           { return(MathArctan_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(char value)                               { return(MathCeil_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(short value)                              { return(MathCeil_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(int value)                                { return(MathCeil_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(long value)                               { return(MathCeil_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(uchar value)                              { return(MathCeil_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(ushort value)                             { return(MathCeil_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(uint value)                               { return(MathCeil_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(ulong value)                              { return(MathCeil_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(float value)                               { return(MathCeil_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathCeil(double value)                             { return(MathCeil_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathCos(char value )                               { return(MathCos_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathCos(short value )                              { return(MathCos_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathCos(int value)                                 { return(MathCos_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathCos(long value)                                { return(MathCos_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathCos(uchar value)                               { return(MathCos_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathCos(ushort value)                              { return(MathCos_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathCos(uint value)                                { return(MathCos_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathCos(ulong value)                               { return(MathCos_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathCos(float value)                                { return(MathCos_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathCos(double value)                              { return(MathCos_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathExp(char value)                                { return(MathExp_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathExp(short value)                               { return(MathExp_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathExp(int value)                                 { return(MathExp_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathExp(long value)                                { return(MathExp_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathExp(uchar value)                               { return(MathExp_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathExp(ushort value)                              { return(MathExp_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathExp(uint value)                                { return(MathExp_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathExp(ulong value)                               { return(MathExp_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathExp(float value)                                { return(MathExp_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathExp(double value)                              { return(MathExp_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(char value)                              { return(MathFloor_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(short value)                             { return(MathFloor_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(int value)                               { return(MathFloor_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(long value)                              { return(MathFloor_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(uchar value)                             { return(MathFloor_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(ushort value)                            { return(MathFloor_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(uint value)                              { return(MathFloor_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(ulong value)                             { return(MathFloor_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(float value)                              { return(MathFloor_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathFloor(double value)                            { return(MathFloor_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathLog(char value)                                { return(MathLog_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathLog(short value)                               { return(MathLog_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathLog(int value)                                 { return(MathLog_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathLog(long value)                                { return(MathLog_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathLog(uchar value)                               { return(MathLog_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathLog(ushort value)                              { return(MathLog_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathLog(uint value)                                { return(MathLog_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathLog(ulong value)                               { return(MathLog_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathLog(float value)                                { return(MathLog_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathLog(double value)                              { return(MathLog_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(char value)                              { return(MathLog10_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(short value)                             { return(MathLog10_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(int value)                               { return(MathLog10_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(long value)                              { return(MathLog10_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(uchar value)                             { return(MathLog10_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(ushort value)                            { return(MathLog10_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(uint value)                              { return(MathLog10_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(ulong value)                             { return(MathLog10_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(float value)                              { return(MathLog10_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathLog10(double value)                            { return(MathLog10_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathMod(char value, char value2)                   { return(MathMod_T<double, char, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, double value2)                 { return(MathMod_T<double, char, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, float value2)                  { return(MathMod_T<double, char, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, int value2)                    { return(MathMod_T<double, char, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, long value2)                   { return(MathMod_T<double, char, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, short value2)                  { return(MathMod_T<double, char, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, uchar value2)                  { return(MathMod_T<double, char, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, uint value2)                   { return(MathMod_T<double, char, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, ulong value2)                  { return(MathMod_T<double, char, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(char value, ushort value2)                 { return(MathMod_T<double, char, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, char value2)                 { return(MathMod_T<double, double, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, double value2)               { return(MathMod_T<double, double, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, float value2)                { return(MathMod_T<double, double, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, int value2)                  { return(MathMod_T<double, double, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, long value2)                 { return(MathMod_T<double, double, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, short value2)                { return(MathMod_T<double, double, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, uchar value2)                { return(MathMod_T<double, double, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, uint value2)                 { return(MathMod_T<double, double, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, ulong value2)                { return(MathMod_T<double, double, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(double value, ushort value2)               { return(MathMod_T<double, double, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, char value2)                    { return(MathMod_T<double, int, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, double value2)                  { return(MathMod_T<double, int, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, float value2)                   { return(MathMod_T<double, int, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, int value2)                     { return(MathMod_T<double, int, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, long value2)                    { return(MathMod_T<double, int, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, short value2)                   { return(MathMod_T<double, int, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, uchar value2)                   { return(MathMod_T<double, int, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, uint value2)                    { return(MathMod_T<double, int, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, ulong value2)                   { return(MathMod_T<double, int, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(int value, ushort value2)                  { return(MathMod_T<double, int, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, char value2)                   { return(MathMod_T<double, long, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, double value2)                 { return(MathMod_T<double, long, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, float value2)                  { return(MathMod_T<double, long, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, int value2)                    { return(MathMod_T<double, long, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, long value2)                   { return(MathMod_T<double, long, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, short value2)                  { return(MathMod_T<double, long, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, uchar value2)                  { return(MathMod_T<double, long, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, uint value2)                   { return(MathMod_T<double, long, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, ulong value2)                  { return(MathMod_T<double, long, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(long value, ushort value2)                 { return(MathMod_T<double, long, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, char value2)                  { return(MathMod_T<double, short, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, double value2)                { return(MathMod_T<double, short, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, float value2)                 { return(MathMod_T<double, short, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, int value2)                   { return(MathMod_T<double, short, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, long value2)                  { return(MathMod_T<double, short, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, short value2)                 { return(MathMod_T<double, short, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, uchar value2)                 { return(MathMod_T<double, short, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, uint value2)                  { return(MathMod_T<double, short, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, ulong value2)                 { return(MathMod_T<double, short, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(short value, ushort value2)                { return(MathMod_T<double, short, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, char value2)                  { return(MathMod_T<double, uchar, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, double value2)                { return(MathMod_T<double, uchar, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, float value2)                 { return(MathMod_T<double, uchar, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, int value2)                   { return(MathMod_T<double, uchar, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, long value2)                  { return(MathMod_T<double, uchar, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, short value2)                 { return(MathMod_T<double, uchar, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, uchar value2)                 { return(MathMod_T<double, uchar, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, uint value2)                  { return(MathMod_T<double, uchar, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, ulong value2)                 { return(MathMod_T<double, uchar, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uchar value, ushort value2)                { return(MathMod_T<double, uchar, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, char value2)                   { return(MathMod_T<double, uint, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, double value2)                 { return(MathMod_T<double, uint, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, float value2)                  { return(MathMod_T<double, uint, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, int value2)                    { return(MathMod_T<double, uint, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, long value2)                   { return(MathMod_T<double, uint, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, short value2)                  { return(MathMod_T<double, uint, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, uchar value2)                  { return(MathMod_T<double, uint, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, uint value2)                   { return(MathMod_T<double, uint, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, ulong value2)                  { return(MathMod_T<double, uint, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(uint value, ushort value2)                 { return(MathMod_T<double, uint, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, char value2)                  { return(MathMod_T<double, ulong, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, double value2)                { return(MathMod_T<double, ulong, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, float value2)                 { return(MathMod_T<double, ulong, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, int value2)                   { return(MathMod_T<double, ulong, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, long value2)                  { return(MathMod_T<double, ulong, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, short value2)                 { return(MathMod_T<double, ulong, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, uchar value2)                 { return(MathMod_T<double, ulong, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, uint value2)                  { return(MathMod_T<double, ulong, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, ulong value2)                 { return(MathMod_T<double, ulong, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ulong value, ushort value2)                { return(MathMod_T<double, ulong, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, char value2)                 { return(MathMod_T<double, ushort, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, double value2)               { return(MathMod_T<double, ushort, double>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, float value2)                { return(MathMod_T<double, ushort, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, int value2)                  { return(MathMod_T<double, ushort, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, long value2)                 { return(MathMod_T<double, ushort, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, short value2)                { return(MathMod_T<double, ushort, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, uchar value2)                { return(MathMod_T<double, ushort, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, uint value2)                 { return(MathMod_T<double, ushort, uint>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, ulong value2)                { return(MathMod_T<double, ushort, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(ushort value, ushort value2)               { return(MathMod_T<double, ushort, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, char value2)                   { return(MathMod_T<double, float, char>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, float value2)                  { return(MathMod_T<double, float, float>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, int value2)                    { return(MathMod_T<double, float, int>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, long value2)                   { return(MathMod_T<double, float, long>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, short value2)                  { return(MathMod_T<double, float, short>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, uchar value2)                  { return(MathMod_T<double, float, uchar>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, ulong value2)                  { return(MathMod_T<double, float, ulong>(value, value2)); }
            double dbg_mqlapi_trace_func_MathMod(float value, ushort value2)                 { return(MathMod_T<double, float, ushort>(value, value2)); }
            double dbg_mqlapi_trace_func_MathPow(char base, char exponent)                  { return(MathPow_T<double, char, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, double exponent)                { return(MathPow_T<double, char, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, float exponent)                 { return(MathPow_T<double, char, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, int exponent)                   { return(MathPow_T<double, char, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, long exponent)                  { return(MathPow_T<double, char, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, short exponent)                 { return(MathPow_T<double, char, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, uchar exponent)                 { return(MathPow_T<double, char, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, uint exponent)                  { return(MathPow_T<double, char, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, ulong exponent)                 { return(MathPow_T<double, char, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(char base, ushort exponent)                { return(MathPow_T<double, char, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, char exponent)                { return(MathPow_T<double, double, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, double exponent)              { return(MathPow_T<double, double, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, float exponent)               { return(MathPow_T<double, double, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, int exponent)                 { return(MathPow_T<double, double, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, long exponent)                { return(MathPow_T<double, double, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, short exponent)               { return(MathPow_T<double, double, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, uchar exponent)               { return(MathPow_T<double, double, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, uint exponent)                { return(MathPow_T<double, double, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, ulong exponent)               { return(MathPow_T<double, double, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(double base, ushort exponent)              { return(MathPow_T<double, double, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, char exponent)                   { return(MathPow_T<double, int, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, double exponent)                 { return(MathPow_T<double, int, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, float exponent)                  { return(MathPow_T<double, int, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, int exponent)                    { return(MathPow_T<double, int, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, long exponent)                   { return(MathPow_T<double, int, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, short exponent)                  { return(MathPow_T<double, int, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, uchar exponent)                  { return(MathPow_T<double, int, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, uint exponent)                   { return(MathPow_T<double, int, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, ulong exponent)                  { return(MathPow_T<double, int, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(int base, ushort exponent)                 { return(MathPow_T<double, int, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, char exponent)                  { return(MathPow_T<double, long, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, double exponent)                { return(MathPow_T<double, long, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, float exponent)                 { return(MathPow_T<double, long, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, int exponent)                   { return(MathPow_T<double, long, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, long exponent)                  { return(MathPow_T<double, long, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, short exponent)                 { return(MathPow_T<double, long, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, uchar exponent)                 { return(MathPow_T<double, long, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, uint exponent)                  { return(MathPow_T<double, long, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, ulong exponent)                 { return(MathPow_T<double, long, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(long base, ushort exponent)                { return(MathPow_T<double, long, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, char exponent)                 { return(MathPow_T<double, short, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, double exponent)               { return(MathPow_T<double, short, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, float exponent)                { return(MathPow_T<double, short, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, int exponent)                  { return(MathPow_T<double, short, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, long exponent)                 { return(MathPow_T<double, short, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, short exponent)                { return(MathPow_T<double, short, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, uchar exponent)                { return(MathPow_T<double, short, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, uint exponent)                 { return(MathPow_T<double, short, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, ulong exponent)                { return(MathPow_T<double, short, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(short base, ushort exponent)               { return(MathPow_T<double, short, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, char exponent)                 { return(MathPow_T<double, uchar, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, double exponent)               { return(MathPow_T<double, uchar, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, float exponent)                { return(MathPow_T<double, uchar, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, int exponent)                  { return(MathPow_T<double, uchar, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, long exponent)                 { return(MathPow_T<double, uchar, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, short exponent)                { return(MathPow_T<double, uchar, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, uchar exponent)                { return(MathPow_T<double, uchar, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, uint exponent)                 { return(MathPow_T<double, uchar, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, ulong exponent)                { return(MathPow_T<double, uchar, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uchar base, ushort exponent)               { return(MathPow_T<double, uchar, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, char exponent)                  { return(MathPow_T<double, uint, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, double exponent)                { return(MathPow_T<double, uint, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, float exponent)                 { return(MathPow_T<double, uint, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, int exponent)                   { return(MathPow_T<double, uint, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, long exponent)                  { return(MathPow_T<double, uint, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, short exponent)                 { return(MathPow_T<double, uint, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, uchar exponent)                 { return(MathPow_T<double, uint, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, uint exponent)                  { return(MathPow_T<double, uint, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, ulong exponent)                 { return(MathPow_T<double, uint, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(uint base, ushort exponent)                { return(MathPow_T<double, uint, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, char exponent)                 { return(MathPow_T<double, ulong, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, double exponent)               { return(MathPow_T<double, ulong, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, float exponent)                { return(MathPow_T<double, ulong, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, int exponent)                  { return(MathPow_T<double, ulong, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, long exponent)                 { return(MathPow_T<double, ulong, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, short exponent)                { return(MathPow_T<double, ulong, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, uchar exponent)                { return(MathPow_T<double, ulong, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, uint exponent)                 { return(MathPow_T<double, ulong, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, ulong exponent)                { return(MathPow_T<double, ulong, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ulong base, ushort exponent)               { return(MathPow_T<double, ulong, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, char exponent)                { return(MathPow_T<double, ushort, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, double exponent)              { return(MathPow_T<double, ushort, double>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, float exponent)               { return(MathPow_T<double, ushort, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, int exponent)                 { return(MathPow_T<double, ushort, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, long exponent)                { return(MathPow_T<double, ushort, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, short exponent)               { return(MathPow_T<double, ushort, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, uchar exponent)               { return(MathPow_T<double, ushort, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, uint exponent)                { return(MathPow_T<double, ushort, uint>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, ulong exponent)               { return(MathPow_T<double, ushort, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(ushort base, ushort exponent)              { return(MathPow_T<double, ushort, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, char exponent)                  { return(MathPow_T<double, float, char>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, float exponent)                 { return(MathPow_T<double, float, float>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, int exponent)                   { return(MathPow_T<double, float, int>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, long exponent)                  { return(MathPow_T<double, float, long>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, short exponent)                 { return(MathPow_T<double, float, short>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, uchar exponent)                 { return(MathPow_T<double, float, uchar>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, ulong exponent)                 { return(MathPow_T<double, float, ulong>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathPow(float base, ushort exponent)                { return(MathPow_T<double, float, ushort>(base, exponent)); }
            double dbg_mqlapi_trace_func_MathRound(char value)                              { return(MathRound_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathRound(short value)                             { return(MathRound_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathRound(int value)                               { return(MathRound_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathRound(long value)                              { return(MathRound_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathRound(uchar value)                             { return(MathRound_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathRound(ushort value)                            { return(MathRound_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathRound(uint value)                              { return(MathRound_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathRound(ulong value)                             { return(MathRound_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathRound(float value)                              { return(MathRound_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathRound(double value)                            { return(MathRound_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathSin(char value)                                { return(MathSin_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathSin(short value)                               { return(MathSin_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathSin(int value)                                 { return(MathSin_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathSin(long value)                                { return(MathSin_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathSin(uchar value)                               { return(MathSin_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathSin(ushort value)                              { return(MathSin_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathSin(uint value)                                { return(MathSin_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathSin(ulong value)                               { return(MathSin_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathSin(float value)                                { return(MathSin_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathSin(double value)                              { return(MathSin_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(char value)                               { return(MathSqrt_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(short value)                              { return(MathSqrt_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(int value)                                { return(MathSqrt_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(long value)                               { return(MathSqrt_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(uchar value)                              { return(MathSqrt_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(ushort value)                             { return(MathSqrt_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(uint value)                               { return(MathSqrt_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(ulong value)                              { return(MathSqrt_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(float value)                               { return(MathSqrt_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathSqrt(double value)                             { return(MathSqrt_T<double, double>(value)); }
            double dbg_mqlapi_trace_func_MathTan(char value)                                { return(MathTan_T<double, char>(value)); }
            double dbg_mqlapi_trace_func_MathTan(short value)                               { return(MathTan_T<double, short>(value)); }
            double dbg_mqlapi_trace_func_MathTan(int value)                                 { return(MathTan_T<double, int>(value)); }
            double dbg_mqlapi_trace_func_MathTan(long value)                                { return(MathTan_T<double, long>(value)); }
            double dbg_mqlapi_trace_func_MathTan(uchar value)                               { return(MathTan_T<double, uchar>(value)); }
            double dbg_mqlapi_trace_func_MathTan(ushort value)                              { return(MathTan_T<double, ushort>(value)); }
            double dbg_mqlapi_trace_func_MathTan(uint value)                                { return(MathTan_T<double, uint>(value)); }
            double dbg_mqlapi_trace_func_MathTan(ulong value)                               { return(MathTan_T<double, ulong>(value)); }
            double dbg_mqlapi_trace_func_MathTan(float value)                                { return(MathTan_T<double, float>(value)); }
            double dbg_mqlapi_trace_func_MathTan(double value)                              { return(MathTan_T<double, double>(value)); }
            int dbg_mqlapi_trace_func_Minute()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = Minute();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Month()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = Month();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ObjectDescription(string object_name)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, object_name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectDescription(object_name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_ObjectGet(string object_name, int index)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, object_name, index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectGet(object_name, index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ObjectGetFiboDescription(string object_name, int index)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, object_name, index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectGetFiboDescription(object_name, index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectGetShiftByValue(string object_name, double value)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, object_name, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectGetShiftByValue(object_name, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_ObjectGetValueByShift(string object_name, int shift)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, object_name, shift, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectGetValueByShift(object_name, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSet(string object_name, int index, double value)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, object_name, index, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectSet(object_name, index, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetFiboDescription(string object_name, int index, string text)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, object_name, index, text, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectSetFiboDescription(object_name, index, text);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetText(string object_name, string text, int font_size = 0, string font_name = NULL, color text_color = clrNONE)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, object_name, text, font_size, font_name, text_color, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectSetText(object_name, text, font_size, font_name, text_color);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectType(string object_name)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, object_name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ObjectType(object_name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderClose(int ticket, double lots, double price, int slippage, color arrow_color)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, ticket, lots, price, slippage, arrow_color, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderClose(ticket, lots, price, slippage, arrow_color);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderCloseBy(int ticket, int opposite, color arrow_color)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, ticket, opposite, arrow_color, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderCloseBy(ticket, opposite, arrow_color);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderClosePrice()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderClosePrice();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_OrderCloseTime()
            {
                datetime retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderCloseTime();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_OrderComment()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderComment();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderCommission()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderCommission();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderDelete(int ticket, color arrow_color)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket, arrow_color, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderDelete(ticket, arrow_color);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_OrderExpiration()
            {
                datetime retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderExpiration();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderLots()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderLots();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_OrderMagicNumber()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderMagicNumber();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderModify(int ticket, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, ticket, price, stoploss, takeprofit, expiration, arrow_color, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderModify(ticket, price, stoploss, takeprofit, expiration, arrow_color);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderOpenPrice()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderOpenPrice();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_OrderOpenTime()
            {
                datetime retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderOpenTime();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderProfit()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderProfit();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderSelect(int index, int select, int pool = MODE_TRADES)
            {
                bool                            retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, index, select, pool, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderSelect(index, select, pool);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_OrderSend(string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment = NULL, int magic = 0, datetime expiration = 0, color arrow_color = clrNONE)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, comment, magic, expiration, arrow_color, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, cmd, volume, price, slippage, stoploss, takeprofit);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderSend(symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

            int dbg_mqlapi_trace_func_OrdersHistoryTotal()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrdersHistoryTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderStopLoss()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderStopLoss();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderSwap()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderSwap();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_OrderSymbol()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderSymbol();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderTakeProfit()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderTakeProfit();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_OrderTicket()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderTicket();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_OrderType()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = OrderType();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Period()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = Period();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_RefreshRates()
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = RefreshRates();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Seconds()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = Seconds();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ushort dbg_mqlapi_trace_func_StringGetChar(string string_value, int pos)
            {
                ushort         retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, string_value, pos, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = StringGetChar(string_value, pos);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_StringSetChar(string string_var, int pos, ushort value)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, string_var, pos, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = StringSetChar(string_var, pos, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_StringTrimLeft(const string text)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, text, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = StringTrimLeft(text);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, text, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_StringTrimRight(const string text)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, text, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = StringTrimRight(text);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, text, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_StrToDouble(string value)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = StrToDouble(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StrToInteger(string value)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = StrToInteger(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_StrToTime(string value)
            {
                datetime retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = StrToTime(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_TerminalCompany()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TerminalCompany();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_TerminalName()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TerminalName();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_TerminalPath()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TerminalPath();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeDay(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeDay(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeDayOfWeek(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeDayOfWeek(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeDayOfYear(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeDayOfYear(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeHour(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeHour(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeMinute(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeMinute(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeMonth(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeMonth(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeSeconds(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeSeconds(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_TimeToStr(datetime value, int mode = TIME_DATE | TIME_MINUTES)
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value, mode, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeToStr(value, mode);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeYear(datetime date)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, date, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = TimeYear(date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowBarsPerChart()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowBarsPerChart();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_WindowExpertName()
            {
                string retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowExpertName();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowFind(string name)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowFind(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowFirstVisibleBar()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowFirstVisibleBar();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowHandle(string symbol, int timeframe)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, timeframe, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowHandle(symbol, timeframe);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowIsVisible(int index)
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowIsVisible(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowOnDropped()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_WindowPriceMax(int index = 0)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowPriceMax(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_WindowPriceMin(int index = 0)
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowPriceMin(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_WindowPriceOnDropped()
            {
                double retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowPriceOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_WindowScreenShot(string filename, int size_x, int size_y, int start_bar = -1, int chart_scale = -1, int chart_mode = -1)
            {
                bool retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, filename, size_x, size_y, start_bar, chart_scale, chart_mode, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowScreenShot(filename, size_x, size_y, start_bar, chart_scale, chart_mode);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowsTotal()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowsTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_WindowTimeOnDropped()
            {
                datetime retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowTimeOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowXOnDropped()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowXOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WindowYOnDropped()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = WindowYOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Year()
            {
                int retval;
                _return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = Year();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };


        // MQL-API void-typed function rewrite

            void dbg_mqlapi_trace_func_HideTestIndicators(bool hide)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, hide, 0, 0, 0, 0, 0, 0);
                HideTestIndicators(hide);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_IndicatorDigits(int digits)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, digits, 0, 0, 0, 0, 0, 0);
                IndicatorDigits(digits);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_IndicatorShortName(string name)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                IndicatorShortName(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_MQLSetInteger(int property_id, int property_value)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, property_id, property_value, 0, 0, 0, 0, 0);
                MQLSetInteger(property_id, property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_OrderPrint()
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                OrderPrint();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetIndexArrow(int index, int code)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, index, code, 0, 0, 0, 0, 0);
                SetIndexArrow(index, code);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetIndexDrawBegin(int index, int begin)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, index, begin, 0, 0, 0, 0, 0);
                SetIndexDrawBegin(index, begin);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetIndexEmptyValue(int index, double value)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, index, value, 0, 0, 0, 0, 0);
                SetIndexEmptyValue(index, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetIndexLabel(int index, string text)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, index, text, 0, 0, 0, 0, 0);
                SetIndexLabel(index, text);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetIndexShift(int index, int shift)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, index, shift, 0, 0, 0, 0, 0);
                SetIndexShift(index, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetIndexStyle(int index, int type, int style = EMPTY, int width = EMPTY, color clr = clrNONE)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, index, type, style, width, clr, 0, 0);
                SetIndexStyle(index, type, style, width, clr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetLevelStyle(int draw_style, int line_width, color clr)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, draw_style, line_width, clr, 0, 0, 0, 0);
                SetLevelStyle(draw_style, line_width, clr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetLevelValue(int level, double value)
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, level, value, 0, 0, 0, 0, 0);
                SetLevelValue(level, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_WindowRedraw()
            {
                string retval = "NV";
                _return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                WindowRedraw();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
    };

//
/////////////////////////////////////////////////////////////////////////////////////////////////////


//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_MQLAPI_MQL4_TRACER_MQH_INCLUDED
