#ifndef LIB_DBG_DEBUG_INJECTOR_MQL5_TRACER_MQH_INCLUDED
#define LIB_DBG_DEBUG_INJECTOR_MQL5_TRACER_MQH_INCLUDED
#property version "1.0";
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the debugger library include file.
 *
 * This file may be copied and/or distributed at free will.
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 1.0
 *  State: public
 *
 *  File information
 *  ================
 *
*/




//*********************************************************************************************************************************************************/
//  BEGIN MQLAPI tracer
//


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MQL5 Standard library object injection
//



    ////////////////////////////////////////
    //
    // CObject injector
    //

        #define CObject _CObject
        #include <Object.mqh>
        #undef CObject
        
        class CObject : public _CObject
        {
            public:
            LIB_DBG_NAMESPACE(dbg_lib, mqlapi_call_tracer_object_stdlib_CObject)*     dbg_mql_api_call_tracer;
        
            CObject() : 
                dbg_mql_api_call_tracer(NULL)
            { };
        
            ~CObject()
            { if(dbg_mql_api_call_tracer != NULL) { delete(dbg_mql_api_call_tracer); } }
        };



    ////////////////////////////////////////
    //
    // CCanvas injector
    //

        #define CCanvas _CCanvas
        #include <Canvas\Canvas.mqh>
        #undef CCanvas
        
        class CCanvas : public _CCanvas
        {
            public:
            LIB_DBG_NAMESPACE(dbg_lib, mqlapi_call_tracer_object_stdlib_CCanvas)<_CCanvas>*     dbg_mql_api_call_tracer;
        
            CCanvas() : 
                dbg_mql_api_call_tracer(new LIB_DBG_NAMESPACE(dbg_lib, mqlapi_call_tracer_object_stdlib_CCanvas)<_CCanvas>(GetPointer(this)))
            { };
        
            ~CCanvas()
            { delete(dbg_mql_api_call_tracer); }
        };



//
/////////////////////////////////////////////////////////////////////////////////////////////////////



//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_INJECTOR_MQL5_TRACER_MQH_INCLUDED
